<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Pushdown Automata</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070619;14110000">
	<META NAME="CHANGED" CONTENT="20070710;11363700">
	<STYLE>
	<!--
		@page { size: 8.5in 11in; margin-left: 1.25in; margin-right: 1.25in; margin-top: 1in; margin-bottom: 1in }
		TD P { margin-bottom: 0.08in }
		P { margin-bottom: 0.08in }
		TH P { margin-bottom: 0.08in }
	-->
	</STYLE>
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Building Your First
Pushdown Automaton</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A><U><BR></U><A HREF="#how to"><U>How
to Create an Automaton</U></A><U> <BR></U><A HREF="#npda"><U>Nondeterministic
NPDAs</U></A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">JFLAP defines a nondeterministic
pushdown automaton (NPDA) <I>M</I> as the septuple <I>M</I> = (<I>Q</I>,
Σ<!--capital sigma-->, Γ, δ<!--small delta-->, <I>q<SUB>s</SUB></I>,
<I>Z, F</I>) where 
</P>
<P><I>Q</I> is a finite set of states {<I>q<SUB>i</SUB></I> | <I>i</I>
is a nonnegative integer}<BR>Σ is the finite input alphabet 
</P>
<P>Γ is the finite stack alphabet <BR>δ is the transition function,
δ : <I>Q</I> &times;<!--times--> Σ* &times;<!--times--> Γ* →
finite subsets of <I>Q</I> &times;<!--times--> Γ* <BR><I>q<SUB>s</SUB></I>
(is member of<!--&#8712;--><!--element of--> <I>Q</I>) is the initial
state 
</P>
<P><I>Z</I> is the start stack symbol (must be a capital Z)<BR><I>F</I>
(is a subset of<!--&#8839--><!--subset of or equal--> <I>Q</I>) is
the set of final states 
</P>
<P>Note that this definition includes deterministic pushdown
automata, which are simply nondeterministic pushdown automata with
only one available route to take.</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Create an Automaton</H2>
<P>For knowledge of many of the general tools, menus, and windows
used to create an automaton, one should first read the tutorial on
<A HREF="../../fa/createfa/fa.html">finite automata</A>. This
tutorial will principally focus on features and options that
differentiate pushdown automata from finite automata.</P>
<P ALIGN=LEFT><A NAME="language1"></A>We will begin by constructing a
deterministic NPDA for the language <I>L</I> = {<I>a<SUP>n</SUP>b<SUP>n</SUP></I>
: n &gt;<!--greater than--> 0}. Our approach is to push an “a” on
the stack for each “a” in the input, and to pop an “a” off
the stack for each “b” in the input. To start a new NPDA, start
JFLAP and click the <B>Pushdown Automaton</B> option from the menu,
as shown below:</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/mainmenu" NAME="Graphic1" ALIGN=MIDDLE WIDTH=233 HEIGHT=321 BORDER=0></P>
<P STYLE="margin-bottom: 0in">One should eventually see a blank
screen that looks like the screen below. There are many of the same
buttons, menus, and features present that exist for finite automata.
However, there are a few differences, which we will encounter
shortly.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/blankeditor" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Four states should be enough
for the language <I>L</I> = {<I>a<SUP>n</SUP>b<SUP>n</SUP></I> : n &gt;<!--greater than-->
0}. Add four states to the screen, setting the initial state to be q0
and the final state to be q3. The screen should look similar to one
below.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/added4states" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now its time to add the
transitions. Attempt to add a transition between the states q0 and
q1. However, there is something different about these transitions in
comparison to those created with finite automata. One will notice
that there are three inputs instead of one.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/newtransition" NAME="Graphic4" ALIGN=MIDDLE WIDTH=224 HEIGHT=15 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The value in the first box
represents the input to be processed, the value in the second box
represents the current value at the top of the stack, and the final
value represents the new value to be pushed onto the top of the
stack, after popping the value at the top of the stack off. There is
no limit to the size of the values in any of these boxes. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, it's time to add input.
To change the transition from the default, click on the first box.
Enter a value of “a” for the first box, a value of “Z” for
the second box (the default character for the bottom element in the
stack), and a value of “aZ” in the third box. Use Tab or the
mouse to move between the boxes, and press enter or click the mouse
on the screen outside the boxes when done. This transition means the
the following. If the first symbol of the input is “a”, the first
symbol of the stack is “Z”, and the machine is in state “q0”,
then pop off “Z” and push “aZ” onto the stack. This
transition thus adds an “a” to the stack if utilized. When done,
the area between q0 and q1 should resemble the example below.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/addedfirsttransition" NAME="Graphic5" ALIGN=MIDDLE WIDTH=212 HEIGHT=83 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Let's finish up the
transitions. Add a transition (a, a; aa) between q1 and q1 to finish
up the <I>a<SUP>n </SUP></I>segment. Create the transition (b, a; <TT><FONT FACE="Nimbus Roman No9 L">λ</FONT></TT>)
between q1 and q2 and between q2 and q2 to represent the <I>b<SUP>n
</SUP></I>segment. Finally, (<TT><FONT FACE="Nimbus Roman No9 L">λ </FONT></TT>,
Z; Z) between q2 and q3 will allow an input to arrive at the final
state. When finished, the screen should look like this:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/finishedtransitions" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">For your convenience, the
NPDA that we have just made is available in <A HREF="pdaexample.jff">pdaexample.jff</A>.
Now, click on the “Input” menu and select “Step with Closure.”
It will prompt you for input, so enter “aaaabbbb” (representing
<I>a<SUP>4</SUP>b<SUP>4</SUP></I>). After clicking “OK” or
pressing enter, the following screen should come up: 
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/runintro" NAME="Graphic7" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">This is very similar to the
corresponding screen for finite automata. However, a noted difference
is that there is a second box of text in the panel in the lower left.
This text box, which currently contains a 'Z', is our stack. If we
click the step button, we can see an example of how the stack changes
as the simulation runs. There is now be an 'a' in front of the 'Z'.
As we continue the simulation, the stack will be at its largest when
the <I>a<SUP>n </SUP></I>values have been processed, but not any <I>b<SUP>n
</SUP></I>values. However, as the <I>b </I>values are processed, it
will get smaller. The stack will finally end back where it started,
with a value of “Z”. Thus we finish our first deterministic NPDA.</P>
<CENTER>
	<TABLE WIDTH=604 BORDER=0 CELLPADDING=2 CELLSPACING=0>
		<COL WIDTH=149>
		<COL WIDTH=145>
		<COL WIDTH=147>
		<COL WIDTH=147>
		<TR>
			<TH WIDTH=149>
				<P><U>After the first step</U></P>
			</TH>
			<TH WIDTH=145>
				<P><U>After <I>a<SUP>n</SUP></I></U></P>
			</TH>
			<TH WIDTH=147>
				<P><U>After the first <I>b</I> value</U></P>
			</TH>
			<TH WIDTH=147>
				<P><U>When finished</U></P>
			</TH>
		</TR>
		<TR>
			<TD WIDTH=149>
				<P><IMG SRC="images/runstep1" NAME="Graphic8" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0>
								</P>
			</TD>
			<TD WIDTH=145>
				<P><IMG SRC="images/runan" NAME="Graphic10" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD WIDTH=147>
				<P><IMG SRC="images/runfirstb" NAME="Graphic10" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD WIDTH=147>
				<P><IMG SRC="images/runfinished" NAME="Graphic9" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><A NAME="npda"></A><FONT SIZE=5><B>Nondeterministic
NPDAs</B></FONT></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Nondeterministic NPDAs work
in a similar way. One example is the one below, which one can access
online here <A HREF="http://www.cs.duke.edu/csed/jflap/jflapbook/files/ex5.2.jff">here</A>.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/npdaexample" NAME="Graphic11" ALIGN=MIDDLE WIDTH=600 HEIGHT=430 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>The following is a
simulation of “Input → Step by Closure” with the string “aabb”:</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<CENTER>
	<TABLE WIDTH=451 BORDER=0 CELLPADDING=2 CELLSPACING=0>
		<COL WIDTH=148>
		<COL WIDTH=145>
		<COL WIDTH=146>
		<TR>
			<TH WIDTH=148>
				<P><U>Start</U></P>
			</TH>
			<TH WIDTH=145>
				<P><U>Step 1</U></P>
			</TH>
			<TH WIDTH=146>
				<P><U>Step 2</U></P>
			</TH>
		</TR>
		<TR>
			<TD WIDTH=148>
				<P><IMG SRC="images/runnpda0" NAME="Graphic8" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0>
								</P>
			</TD>
			<TD WIDTH=145>
				<P><IMG SRC="images/runnpda1" NAME="Graphic10" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD WIDTH=146>
				<P><IMG SRC="images/runnpda2" NAME="Graphic10" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P ALIGN=LEFT>Now is when the nondeterminism begins to assert itself,
and the automaton can take more than one path. The last steps cover
all possible permutations the program can take, with one path
succeeding in the end.</P>
<CENTER>
	<TABLE CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TH WIDTH=287>
				<P><U>Step 3</U></P>
			</TH>
		</TR>
		<TR>
			<TD WIDTH=287>
				<P><IMG SRC="images/runnpda3" NAME="Graphic9" ALIGN=MIDDLE WIDTH=283 HEIGHT=98 BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<CENTER>
	<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TH>
				<P><U>Step 4</U></P>
			</TH>
		</TR>
		<TR>
			<TD>
				<P><IMG SRC="images/runnpda4" NAME="Graphic8" ALIGN=MIDDLE WIDTH=566 HEIGHT=97 BORDER=0>
								</P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<CENTER>
	<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TH>
				<P><U>Results</U></P>
			</TH>
		</TR>
		<TR>
			<TD>
				<P><IMG SRC="images/runnpda5" NAME="Graphic8" ALIGN=MIDDLE WIDTH=567 HEIGHT=95 BORDER=0>
								</P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P ALIGN=LEFT>(Note: This example taken from <I>JFLAP: An Interactive
Formal Languages and Automata Package</I> by Susan Rodger and Thomas
Finley.) 
</P>
<P ALIGN=LEFT><B>This concludes our brief tutorial on building
pushdown automata. Thanks for reading!</B></P>
</BODY>
</HTML>